/*

Based on FileName: APIWrapper.js from Concurrent Technologies Corporation (CTC).

Comments removed (-- those bytes have to be transmitted --) and formatting standardised. 

*/

/****   C O N F I G U R A T I O N   ****/

var	searchLimitMax = 16; // Max depth searching for API
var searchLimit = 0; // limit

var searchForAPIMode = "A"; 
/*
	Search modes:
	A - search opener first then parent
	B - search parent first then opener
	C - search opener only
	D - search parent only
*/

/****   C O N F I G U R A T I O N  ends ****/

var _Debug = false;
var _DebugLMSCalls = false; 
var _NoError = 0;
var _GeneralException = 101;
var _InvalidArgumentError = 201;
var _NotInitialized = 301;
var _NotImplementedError = 401;

var scormAPIMonitorGetValue = null;
var scormAPIMonitorSetValue = null;
var	scormCommLog = null;

var apiHandle = null;

function LMSInitialize()
{
	var api = getAPIHandle();
	if (api == null)
	{
		alert("Unable to locate the LMS's API Implementation.\n\nLMSInitialize was not successful.");
		return false;
	}
	var initResult = api.LMSInitialize("");
	if (initResult.toString() != "1")
	{
		var err = ErrorHandler();
	}
	return initResult;
}

function LMSFinish()
{
	var api = getAPIHandle();
	if (api == null) alert("Unable to locate the LMS's API Implementation.\n\nLMSFinish was not successful.");
	else
	{
		api.LMSFinish("");
		var err = ErrorHandler();
	}
}

function LMSLogComm(getSet,name,value)
{
	if(!scormCommLog) scormCommLog = new Array();
	scormCommLog.push(getSet + " " + name + " = " + value);
}

function LMSGetValue(name)
{
	var api = getAPIHandle();
	if(api == null)
	{
		alert("Unable to locate the LMS's API Implementation.\nLMSGetValue was not successful.");
		return null;
	}
	else
	{
		var value = api.LMSGetValue(name);
		if(scormAPIMonitorGetValue) scormAPIMonitorGetValue(name,value);
		if(scormLogComm) LMSLogComm("GET",name,value);
		var err = ErrorHandler();
		if(err != _NoError) return null;
		else return value.toString();
	}
}

function LMSSetValue(name, value)
{
	var api = getAPIHandle();
	if(api == null) alert("Unable to locate the LMS's API Implementation.\nLMSSetValue was not successful.");
	else
	{
		api.LMSSetValue(name, value);
		if(scormAPIMonitorSetValue) scormAPIMonitorSetValue(name,value);
		if(scormLogComm) LMSLogComm("SET",name,value);
		var err = ErrorHandler();
	}
}

function LMSCommit()
{
	var api = getAPIHandle();
	if (api == null) alert("Unable to locate the LMS's API Implementation.\nLMSCommit was not successful.");
	else
	{
		api.LMSCommit("");
		var err = ErrorHandler();
	}
}

function LMSGetLastError()
{
	var api = getAPIHandle();
	if (api == null)
	{
		alert("Unable to locate the LMS's API Implementation.\nLMSGetLastError was not successful.");
		return _GeneralError;
	}
	return api.LMSGetLastError().toString();
}

function LMSGetErrorString(errorCode)
{
var api = getAPIHandle();
if (api == null) alert("Unable to locate the LMS's API Implementation.\nLMSGetErrorString was not successful.");
return api.LMSGetErrorString(errorCode).toString();
}

function LMSGetDiagnostic(errorCode)
{
var api = getAPIHandle();
if (api == null) alert("Unable to locate the LMS's API Implementation.\nLMSGetErrorString was not successful.");
return api.LMSGetDiagnostic(errorCode).toString();
}

function LMSIsInitialized()
{
	var api = getAPIHandle();
	if(api == null)
	{
		alert("Unable to locate the LMS's API Implementation.\nLMSIsInitialized() failed.");
		return false;
	}
	else
	{
		var value = api.LMSGetValue("cmi.core.student_name");
		var errCode = api.LMSGetLastError().toString();
		if(errCode == _NotInitialized) return false;
		else return true;
	}
}

function ErrorHandler()
{
	var api = getAPIHandle();
	if(api == null)
	{
		alert("Unable to locate the LMS's API Implementation.\nCannot determine LMS error code.");
		return;
	}
	var errCode = _NoError;
	try
	{
		api.LMSGetLastError().toString();
	}
	catch(e) {}
	if(errCode != _NoError)
	{
		var errDescription = api.LMSGetErrorString(errCode);
		if(_Debug == true)
		{
			errDescription += "\n";
			errDescription += api.LMSGetDiagnostic(null);
		}
		if(_DebugLMSCalls) alert(errDescription);
	}
	return errCode;
}

function getAPIHandle()
{
	searchLimit = searchLimitMax;
	if (apiHandle == null) apiHandle = searchAPI(window);
	return apiHandle;
}

function debugFindAPI(win)
{
alert("win is: "+win.location.href);
if(win.API != null)
{
	alert("found api in this window");
	return win.API;
}
if(win.length > 0)  
{
	alert("looking for api in windows frames");
	for(var i=0; i < win.length; i++)
	{
		alert("looking for api in frames["+i+"]");
		var theAPI = findAPI(win.frames[i]);
		if (theAPI != null) return theAPI;
	}
}
alert("didn't find api in this window (or its children)");
return null;
}

function cleanFindAPI(win)
{
if(win.API != null) return win.API;
if(win.length > 0)
{
	for (var i=0; i < win.length; i++)
	{
		var theAPI = findAPI(win.frames[i]);
		if (theAPI != null) return theAPI;
	}
}
return null;
}

function findAPI(win)
{
	if(_Debug) return debugFindAPI(win);
	else return cleanFindAPI(win);
}

function searchAPI_A(win)
{
	var t = findAPI(win);
	if(!t)
	{
		if(win.opener) t = searchAPI(win.opener);
		if(!t && win.parent && searchLimit)
		{
			searchLimit--;
			t = searchAPI(win.parent);
		}
	}
	return t;
}

function searchAPI_B(win)
{
	var t = findAPI(win);
	if(!t)
	{
		if(win.parent) t = searchAPI(win.parent);
		if(!t && win.opener && searchLimit)
		{
			searchLimit--;
			t = searchAPI(win.opener);
		}
	}
	return t;
}

function searchAPI_C(win)
{
	var t = findAPI(win);
	if(!t)
	{
		if(win.opener) t = searchAPI(win.opener);
	}
	return t;
}

function searchAPI_D(win)
{
	var t = findAPI(win);
	if(!t)
	{
		if(win.parent) t = searchAPI(win.parent);
	}
	return t;
}

function searchAPI(win)
{
	switch(searchForAPIMode)
	{
	case "A": return searchAPI_A(win);
	case "B": return searchAPI_B(win);
	case "C": return searchAPI_C(win);
	case "D": return searchAPI_D(win);
	}
}
