/*
	Software Copyright (c) 1985-2013 Information Transfer LLP

	Seminar 7.5.8.1018 - DIAMOND

	delivery-target: 0 = standalone web, 1 = SCORM, 2 = NETg

	score-detail: 0 = none, 1 = module, 2 = sections, 3 = questions, 4 = elements

	conditionType: 0 = none, 1 = moduleLessThan, 2 = moduleAtLeast, 3 = sectionLessThan, 4 = sectionAtLeast

	run-mode: 0 = Learning, 1 = Assessment, 2 = Exam, 3 = Survey

	finishing post: 0 = none/auto, 1 = user section, 2 = user module, 3 = auto section, 4 = auto module
*/

var controlWindow = parent.controlWindow;
var presentWindow = parent.presentWindow;
var	scoreWindow = parent.scoreWindow;
var preloadWindow = parent.preloadWindow;
var debugWindow = null;
var debugStop = false;

var	debugHistory = false;

var currentPage = null;
var startPage = null;

var deliveryTarget = 0;
var controlModuleClock = new Date();
var	controlTimedModuleStartMS = 0;
var	controlStartClockDrift = 0;
var	controlClockDriftChecked = false;
var serverStartTime = null;

var	examModeReview = false;

var	user = new Object();
	user.firstName = "";
	user.lastName = "";
	user.additional1 = "";
	user.additional2 = "";
	user.additional3 = "";
	user.signedOn = false;

var refStack = new Array();
var pageHistory = new Array();
var pageHistoryIndex = -1;
var	controlPagePreview = false;
var controlEjecting = false;
var controlEjectedPage = null;
var controlMenuQuit = false;
var controlPageLoading = false;
var	controlRunning = false;
var	controlSCORMreloading = false;
var controlFinishing = false;
var controlModuleComplete = false;
var	controlQuestionNumber = 0;
var controlOnPageChange = null;

var detectedIE = false;
var detectedOpera = false;
var detectedFirefox = false;
var detectedSafari = false;
var detectedChrome = false;
var detectedSafariOrChrome = false;

function debugInit()
{
	debugWindow = window.open("","Debug","");
	debugWindow.document.write("<span style='font-family:Courier New;font-size:8pt;color:#000000'>");
}    

function debugLocations()
{
	alert("controlWindow.location=" + controlWindow.location + "\n" + "presentWindow.location=" + presentWindow.location);
}

function debugCurrentPage()
{
	if(currentPage)	alert("currentPage.filename=" + currentPage.filename)
	else alert("currentPage=null");
}

function debugTraceLn(s)
{
	if(!debugWindow) debugInit();
	if(debugWindow) debugWindow.document.writeln(s + "<br>");
}

function debugClearTrace()
{
	if(!debugWindow) debugInit();
	if(debugWindow)
	{
		debugWindow.location = "blank.html";
		debugWindow.document.write("<span style='font-family:Courier New;font-size:8pt;color:#000000'>");
	}
}

function debugDumpSectionArray(aSection)
{
	debugTraceLn("Title=" + aSection.title);
	debugTraceLn("Start=" + aSection.startPage.filename);
	debugTraceLn("Link=" + aSection.linkKind);
	for(var p = 0; p < aSection.pages.length; p++)
	{
		var page = aSection.pages[p];
		if(page.nextPage) debugTraceLn("[" + p + "] " + page.filename + " -> " + page.nextPage.filename);
		else debugTraceLn("[" + p + "] " + page.filename + " -> null");
	}
}

function debugDumpSequence()
{
	var page = sections[0].startPage;
	var	tmp = "";
	var s = 0;
	var p = 0;
	while(page)
	{
		p++;
		tmp = "[" + p + "] " + page.filename;
		if(page.prevPage) tmp = tmp + " (" + page.prevPage.filename + ")";
		debugTraceLn(tmp);
		page = page.nextPage;
		if(page.filename == "menu.html")
		{
			s++;
			if(s < sections.length)
			{
				debugTraceLn("Section " + sections[s].title);
				page = sections[s].startPage;
			}
			else page = null;
		}
	}
}

function debugDumpRefStack()
{
	for(var i = 0; i < refStack.length; i++)
	{
		debugTraceLn(i + ": " + refStack[i].filename);
	}
}

function controlIsIE()
{
	if(typeof(document.all)=='object') return true;
	else return false;
}

function controlGetStartPageFromURL()
{
	var aPage = null;
	if(parent && parent.args) 
	{
		var aFilename = parent.args["FILENAME"];
		if(aFilename) aPage = controlGetPageByFilename(aFilename);
	}
	return aPage;
}

function controlGetServerStartTime()
{
    try
    {
        var client = new XMLHttpRequest();
        client.open("HEAD", "control.html", true);
        client.send();
        client.onreadystatechange = function()
            {
				try // fix for #8873
				{
					if(this.readyState == 2)
					{
						var headerDateStr = this.getResponseHeader("Date");
						serverStartTime = new Date(headerDateStr);
					}
				}
				catch(e){}
            }
    }
    catch(e)
    {
        serverStartTime = new Date();
    }
}


function controlStart()
{
	controlRunning = true;
    controlGetServerStartTime();
	if(parent.args["PREVIEW"] == "yes") controlPagePreview = true;
	if(!startPage) startPage = controlGetStartPageFromURL();
	if(!startPage)
	try
	{
		startPage = sections[0].startPage;
	}
	catch(e){};
	if(!startPage)
	try
		{
			startPage = sections[0].pages[0];
		}
	catch(e) {};
	if(!startPage && menuPage) startPage = menuPage;
	controlRecordHistory(startPage);
	controlLoadPage(startPage);
	controlDoFinishingPost(startPage);
}

function controlFinish()
{
//	if(!controlRunning) return;
	controlFinishing = true;
	controlDoFinishingPost(currentPage);
	if(deliveryTarget == 1) controlFinishSCORM();
	else if(deliveryTarget == 2) controlFinishNETg();
		else controlFinishSimple();
/*
	if(debugWindow)
	{
		alert("Closing debug window");
		debugWindow.close();
		debugWindow = null;
	}
*/
	controlRunning = false;
}

function controlCheckSignedOn()
{
	if(deliveryTarget > 0) return true;
	if(moduleHasSignOn) return user.signedOn;
	else
	{
		if(moduleRunMode == 0 || moduleRunMode == 3) return true;
		else return user.signedOn;
	}
}

function controlCloseWindow()
{
	if(parent.isReview) alert("This module has finished.")
//    else parent.close();
	else top.close();
}

function controlFinishSimple()
{
	if(scoreRecordScores && scoreDetail > 0 && controlCheckSignedOn())
	{
		var scoreData = controlAssembleScoreData();
		controlSendScores(scoreScript,scoreFilename,scoreData);
	}
	else
	{
		if(moduleCloseBrowser) controlCloseWindow();
	}
}

function controlFinishSCORM()
{
	scormCloseDown();
	if(scormCloseMode != 1) controlCloseWindow();
}

function controlFinishNETg()
{
	var wsvmHome = wsvmCloseDown();
	if(parent.opener)
	{
		parent.opener.location = wsvmHome;
		controlCloseWindow();
	}
	else parent.location = wsvmHome;
}

function controlPrevPage(aPage)
{
	var prevPage = null;
	if(aPage) prevPage = aPage.prevPage;
	else prevPage = currentPage.prevPage;
	if(prevPage && prevPage.ismenu)
	{
		controlLoadPage(menuPage);
	}
	else
	{
		if(prevPage)
		{
			if(controlCanLoad(prevPage))
			{
				controlRecordHistory(prevPage)
				controlLoadPage(prevPage);
			}
			else controlPrevPage(prevPage);
		}
		else controlFinish();
	}
}

function controlNextPage(aPage)
{
	var nextPage = null;
	if(aPage) thePage = aPage;
	else thePage = currentPage;
	nextPage = thePage.nextPage;
	if(nextPage)
	{
		if(nextPage.ismenu) controlLoadPage(menuPage);
		else
		{
			if(controlCanLoad(nextPage)) controlLoadPage(nextPage);
			else controlNextPage(nextPage);
		}
	}
	else controlFinish();
}

function controlLoadPageByFilename(aFilename)
{
	var aPage = controlGetPageByFilename(aFilename);
	if(aPage) controlLoadPage(aPage);
}

function controlLoadPageByID(aPageID)
{
	var aPage = controlGetPageByID(aPageID);
	if(aPage)
	{
		controlRecordHistory(aPage);
		controlLoadPage(aPage);
	}
}

function controlGotoSection(sectionIndex)
{
	try
	{
		var newPage = sections[sectionIndex].startPage;
	}
	catch(e) {newPage = null}
	if(newPage)
	{
		controlClearHistory();
		controlRecordHistory(newPage);
		controlLoadPage(newPage);
	}
}

function controlHistorySaveToString()
{
	var tmp = "";
	for(var i = 0; i < pageHistory.length; i++)
	{
		tmp += pageHistory[i].pageID + ",";
		if(debugHistory) debugTraceLn("SAVE [" + i + "] " + pageHistory[i].title);
	}
	if(tmp) 
	{
		tmp += pageHistoryIndex;
		if(debugHistory) debugTraceLn("SAVE PHI = " + pageHistoryIndex);
	}
	return tmp;
}

function controlHistoryLoadFromString(s)
{
	controlClearHistory();
	var idList = s.split(",");
	if(idList.length > 0)
	{
		pageHistoryIndex = idList.pop() * 1;
		if(debugHistory) debugTraceLn("LOAD PHI = " + pageHistoryIndex);
		for(var i = 0; i < idList.length; i++)
		{
			aPage = controlGetPageByID(idList[i]);
			if(aPage) pageHistory.push(aPage);
			if(debugHistory) debugTraceLn("LOAD [" + i + "] " + aPage.title);
		}
	}
}

function controlClearHistory()
{
	while(pageHistory.length > 0) pageHistory.pop();
	pageHistoryIndex = -1;
}

function controlTruncateHistory()
{
	while(pageHistory.length > 0 && pageHistory.length > pageHistoryIndex+1) pageHistory.pop();
}

function controlCanBackwards()
{
	if(pageHistoryIndex > 0) return true;
	else return false;
}

function controlCanForwards()
{
	if(pageHistory.length > 0 && (pageHistoryIndex + 1 < pageHistory.length)) return true;
	else return false;
}

function controlRecordHistory(aPage)
{
	if(aPage)
	{
		if(aPage.noHistory)	aPage.noHistory = false;
		else
		{
			controlTruncateHistory();
			pageHistoryIndex = pageHistory.length;
			pageHistory.push(aPage);
			if(debugHistory) debugTraceLn("REC PHI = " + pageHistoryIndex + "  HL = " + pageHistory.length + " " + aPage.title);
		}
	}
}

function controlBackwards()
{
	if(controlCanBackwards())
	{
		pageHistoryIndex--;
		var newPage = pageHistory[pageHistoryIndex];
		controlLoadPage(newPage);
		if(debugHistory) debugTraceLn("BCK PHI = " + pageHistoryIndex + "  HL = " + pageHistory.length + " " + newPage.title);
	}
	else
	{
		controlPrevPage();
		controlRecordHistory(currentPage);
	}
}

function controlForwards()
{
	if(controlCanForwards())
	{
		pageHistoryIndex++;
		var newPage = pageHistory[pageHistoryIndex];
		controlLoadPage(newPage);
		if(debugHistory) debugTraceLn("FWD PHI = " + pageHistoryIndex + "  HL = " + pageHistory.length + " " + newPage.title);
	}
	else
	{
		controlNextPage();
		controlRecordHistory(currentPage);
	}
}

function controlEject()
{
	controlEjecting = true;
	controlEjectedPage = currentPage;
	if(moduleHasSignOn && !user.signedOn) controlFinish()
	else
	{
		if(menuPage) controlLoadPage(menuPage)
		else controlFinish();
	}
	controlEjecting = false;
}

function controlContinue()
{
	controlNextPage();
	controlRecordHistory(currentPage);
}

function controlCheckLoad(aHref)
{
	var slashPos = aHref.lastIndexOf("/");
	if(slashPos >= 0)
	{
		var	aFilename = aHref.slice(slashPos+1);
		if(currentPage && aFilename && aFilename != currentPage.filename) controlLoadPage(currentPage);
	}
}

function controlFixupCondition(aPage)
{
	if(aPage.conditionType && aPage.conditionValue < 0) aPage.conditionValue = modulePassmark;
}

function controlUnloadDoFinishingPost()
{
	if(currentPage) controlDoFinishingPost(currentPage);
}

function controlFinishAllSections()
{
	for(var s = 0; s < sections.length; s++) sections[s].completed = true;
	controlModuleComplete = true;
}

function controlDoFinishingPost(aPage)
{
	if(!aPage) return;
	if(!controlRunning && !controlSCORMreloading) return;
	if(!aPage.finishingPost) return;
	if(!aPage.sectionObject) return;
	if(aPage.ismenu) return;
	var doIt = false;
	if(aPage.isQuestion) 
	{
		if(aPage.questionType == 10) doIt = aPage.loaded;
		else doIt = aPage.attempted;
	}
	else doIt = true;
	if(aPage.sectionObject.runMode == 0) doIt = true;    
	if(doIt)
	{
		switch(aPage.finishingPost)
		{
		case 1: aPage.sectionObject.completed = true;
				break;
		case 2: controlModuleComplete = true;
				break;
		case 3: aPage.sectionObject.completed = true;
				break;
		case 4: controlModuleComplete = true;
				break;
		}
	}
}

function controlLoadPage(aPage)
{
	if(deliveryTarget == 1)
	{
		var canChange = scormQueryPageChange();
		if(canChange != "true") return;
	}
/* not included
	if(currentPage && currentPage.isQuestion)
	{
		if(!currentPage.attempted && !controlEjecting)
		{
			alert("Not allowed to leave");
			return;
		}
	}
*/
	if(!controlPageLoading)
	{
		controlPageLoading = true;
		if(currentPage) currentPage.isCurrent = false;
		if(controlOnPageChange) controlOnPageChange(1);
		if(aPage.resetQuestionCount) controlQuestionNumber = 0;
		if(aPage.isQuestion && !aPage.loaded) controlQuestionNumber++;
		if(aPage.conditionType) controlFixupCondition(aPage);
		if(isSmoothLoading) controlSwapPresentWindow(aPage.filename);
		else presentWindow.location = aPage.filename;
		currentPage = aPage;
		currentPage.isCurrent = true;
		currentPage.loaded = true;
		controlEjecting = false;
		if(deliveryTarget == 1) scormCheckCommit(aPage);
		if(parent.seminarLoadPageHook) parent.seminarLoadPageHook(currentPage);
		if(controlOnPageChange) controlOnPageChange(2);
//	EmbeddedBrowser - this plug-ugly formation
		try
			{
				external.WebBrowserNotify("loadedPage",currentPage.pageID);
			}
		catch(e) {}	
	}
}

function controlPreloadNextPage()
{
	if(currentPage && currentPage.nextPage)
	{
		preloadWindow.location = "pl" + currentPage.nextPage.filename;
	}
}

function controlGetPageID()
{
	if(currentPage) return currentPage.pageID;
	else return 0;
}

// 	conditionType: 0 = none, 1 = moduleLessThan, 2 = moduleAtLeast, 3 = sectionLessThan, 4 = sectionAtLeast
//	conditionValue: -1 = modulePassmark, any other value = %age
function controlCheckScoreCondition(aPage)
{
	var score = 0;
	if(aPage.conditionType)
	{
		if(aPage.conditionType >= 3) score = controlGetSectionScoreN(aPage.section);
		else score = controlGetModuleScore();
		switch(aPage.conditionType)
		{
			case 0: return true;
			case 1: if(aPage.conditionValue >= 0)
					{
						if(score < aPage.conditionValue) return true;
						else return false;
					}
					else
					{
						if(score < modulePassmark) return true;
						else return false;
					}
			case 2: if(aPage.conditionValue >= 0)
					{
						if(score >= aPage.conditionValue) return true;
						else return false;
					}
					else
					{
						if(score >= modulePassmark) return true;
						else return false;
					}
			case 3: if(score < aPage.conditionValue) return true;
					else return false;
			case 4: if(score >= aPage.conditionValue) return true;
					else return false;
		}
	}
	else return true;
}

// ConditionTypeEx: ctxNone = 0, ctxIs = 1, ctxIsNot = 2

// PlainHTML = 0,
// AnyScorm = 1,
// KnowledgeCentre = 2, MySeminar = 3, CommercialCentre = 4, PlainScorm = 5

function controlCheckDeliveryCondition(aPage)
{
	if(aPage.deliveryConditionType)
	{
		var result = false;
		switch(aPage.deliveryConditionValue)
		{
			case 0: result = deliveryTarget == 0;
					break;
			case 1: result = deliveryTarget == 1;
					break;
			case 2: result = deliverySubType == 2;
					break;
			case 3: result = deliverySubType == 3;
					break;
			case 4: result = deliverySubType == 4;
					break;
			case 5: result = deliverySubType == 5;
					break;
		}
		if(aPage.deliveryConditionType == 2) return !result;
		return result;
	}
	else return true;
}

// devDesktop = 0, devMobile = 1, devIOS = 2, devAndroid = 3, devOther = 4

function controlCheckDeviceCondition(aPage)
{
	aPage.debugString = "one";
	if(aPage.deviceConditionType)
	{
		aPage.debugString = "two";
		var result = false;
		switch(aPage.deviceConditionValue)
		{
			case 0: result = mobileIsnt;
					break;
			case 1: result = !mobileIsnt;
					break;
			case 2: result = mobileIsIOS;
					break;
			case 3: result = mobileIsAndroid;
					break;
			case 4: result = !mobileIsnt;
					break;
		}
		aPage.debugString = "three";
		if(aPage.deviceConditionType == 2) return !result;
		return result;
	}
	else return true;
}

function controlCanLoad(aPage)
{
	var scoreOK = controlCheckScoreCondition(aPage);
	var deliveryOK = controlCheckDeliveryCondition(aPage);
	var deviceOK = controlCheckDeviceCondition(aPage);
	if(aPage.deliveryConditionOp)
	{
		if(deliveryOK) deviceOK = true;
		if(deviceOK) deliveryOK = true;
	}
	if(scoreOK && deliveryOK && deviceOK) return true;
	else return false;
}

function controlPushPage(aPage)
{
	refStack.push(aPage);
	return aPage;
}

function controlPushCurrentPage()
{
	refStack.push(currentPage);
	return currentPage;
}

function controlPopPage()
{
	return refStack.pop();
}

function controlPageIsRef(aPage)
{
	if(aPage.filename.charAt(0) == "r") return true;
	else return false;
} 

function controlFindPageByID(aID)
{
	for(var s = 0; s < sections.length; s++)
	{
		for(var p = 0; p < sections[s].pages.length; p++)
		{
			if(sections[s].pages[p].pageID == aID) return sections[s].pages[p];
		}
	}
	return null;
}

function controlFindPageByTagID(tagID)
{
	for(var s = 0; s < sections.length; s++)
	{
		for(var p = 0; p < sections[s].pages.length; p++)
		{
			if(sections[s].pages[p].tagID == tagID) return sections[s].pages[p];
		}
	}
	return null;
}

function controlFindRefByID(aID)
{
	if(refPages)
	{
		for(var r = 0; r < refPages.length; r++)
			if(refPages[r].pageID == aID) return refPages[r];
	}
	return null;
}

function controlFindRefByTagID(tagID)
{
	if(refPages)
	{
		for(var r = 0; r < refPages.length; r++)
			if(refPages[r].tagID == tagID) return refPages[r];
	}
	return null;
}

function controlFindPrevSection(aSection)
{
	var t = null;
	for(var i = 0; i < sections.length; i++)
	{
		if(sections[i] == aSection) return t;
		else t = sections[i];
	}
	return t;
}

function controlShuffleArray(arr,ofs)
{
	for (var i = 0; i < arr.length; i++) arr[i] = i + ofs;
	for (var i = arr.length - 1; i > 0; i--)
	{
		var j = Math.floor((i + 1) * Math.random());
		var t = arr[i];
		arr[i] = arr[j];
		arr[j] = t;
	}
}

function controlBraidArray(arr,aCount)
{
	var x = aCount;
	for(var i = 0; i < aCount; i++)
	{
		var j = Math.floor(Math.random()*braidLengths[i]);
		for(var n = 0; n < braidLengths[i]; n++)
		{
			if(j == n) arr[i] = braidStarts[i] + j;
			else 
			{
				arr[x] = braidStarts[i] + n;
				x++;
			}
		}
	}
}

function controlApplyShuffleArray(arr,aSection,aFirst,aLast,aCount)
{
	var pnKinds = [];
	for(var i=0; i<aSection.pages.length; i++) {pnKinds[i] = aSection.pages[i].pageNumberKind;}

	var aPage = aSection.pages[arr[0]];
	var	aNextPage = null;
	aPage.nextPage = aNextPage;
	for(var i = 0; i < aCount-1; i++)
	{
		aPage = aSection.pages[arr[i]];
		aNextPage = aSection.pages[arr[i+1]];
		aPage.nextPage = aNextPage;
		aNextPage.nextPage = null;
	}

	for(var i = aCount; i < arr.length; i++) aSection.pages[arr[i]].isQuestionCount = false;
	if(aFirst == 0) aSection.startPage = aSection.pages[arr[0]];
	else aSection.pages[aFirst-1].nextPage = aSection.pages[arr[0]];

	if(aNextPage && aLast < aSection.pages.length-1)
	{
		aNextPage.nextPage = aSection.pages[aLast+1];
	}
	aSection.questionCount = aCount;
	if(aSection.runMode == 1 || aSection.runMode == 2) controlFixShuffledFinishingPostA(aSection);
	else controlFixShuffledFinishingPost(aSection);  
	i = 0;
	var aPage = aSection.startPage;
	while(aPage)
	{
		aPage.pageNumberKind = pnKinds[i];
		aPage = aPage.nextPage;
		i++;
	}	
}

// finishing post: 0 = none/auto, 1 = user section, 2 = user module, 3 = auto section, 4 = auto module

// simple version for Learning mode random ... yea, really!
function controlFixShuffledFinishingPost(aSection)
{
	var fp = 0;
	for(var i = 0; i < aSection.pages.length; i++)
	{
		var p = aSection.pages[i];
		if(p.finishingPost >= 3)
		{
			fp = p.finishingPost;
			p.finishingPost = 0;
		}
	}
	var aPage = aSection.startPage;
	while(aPage)
	{
		var nextPage = aPage.nextPage;
		if(!nextPage) aPage.finishingPost = fp;
		aPage = nextPage;
	}
}

// complex version for Assessment and Exam

function controlFixShuffledFinishingPostA(aSection)
{
	var fp = 0;
	for(var i = 0; i < aSection.pages.length; i++)
	{
		var p = aSection.pages[i];
		if(p.finishingPost >= 3)
		{
			fp = p.finishingPost;
			p.finishingPost = 0;
		}
	}
	var aPage = aSection.startPage;
	while(aPage && !aPage.isQuestion)
	{
		aPage = aPage.nextPage;
	}
	while(aPage)
	{
		var nextPage = aPage.nextPage;
		if(!nextPage || !nextPage.isQuestion) 
		{
			aPage.finishingPost = fp;
			aPage = null;
		}
		else
		{
			aPage = nextPage;
		}
	}
}

function controlBraidPages(aSection,aFirst,aLast,aCount)
{
	var arr = new Array((aLast-aFirst)+1);
	controlBraidArray(arr,aCount);
	controlApplyShuffleArray(arr,aSection,aFirst,aLast,aCount);
	aSection.questionsReq = aCount;
	return arr.join(","); // add this line to fix #8766
}

function controlShufflePages(aSection,aFirst,aLast,aCount)
{
	var arr = new Array((aLast-aFirst)+1);
	controlShuffleArray(arr,aFirst);
	controlApplyShuffleArray(arr,aSection,aFirst,aLast,aCount);
}

function debugDumpRandom(aSection)
{
	var p = 0;
	var aPage = aSection.startPage;
	while(aPage)
	{
		if(aPage.nextPage) debugTraceLn(p + " " + aPage.title + " =>>");
		else debugTraceLn(p + " " + aPage.title + " (null)");
		aPage = aPage.nextPage;
		p++;
	}
}

function controlFixLink(aSection,nextSection)
{
	switch(aSection.linkKind)
	{
		case 0: return null;
		case 1: if(nextSection) return nextSection.startPage
				else return null;
		case 2: return menuPage;
	}
}

function controlUnlinkedLast(aSectionIndex)
{
	var	ok = true;
	var	temp = null;
	
	if(sections[aSectionIndex].startPage) var page = sections[aSectionIndex].startPage;
	else var page = null;

	while(page && ok)
	{
		if(page.section == aSectionIndex)
		{
			temp = page;
			page = page.nextPage;
			if(page) page.prevPage = temp;
		}
		else ok = false;
		if(menuPage && page == menuPage) 
		{
			page = null;
			temp = null;
			ok = false;
		}
	}
	return temp;
}

function controlFixupPageLinks()
{
	var page = null;
	var lastPage = null;
	for(var s = 0; s < sections.length; s++)
	{
		lastPage = controlUnlinkedLast(s);
		if(lastPage)
		{
			if(s+1 < sections.length) lastPage.nextPage = controlFixLink(sections[s],sections[s+1]);
			else lastPage.nextPage = controlFixLink(sections[s],null);
		}
		if(menuPage)
		{
			if(sections[s].startPage) sections[s].startPage.prevPage = menuPage;
		}
	}
}

// pnNumber = 0, pnSame = 1, pnReset = 2	  

function controlCalcPageNumbers()
{
	var page = null;
	var prev = null;
	var pageNo = 1;
	for(var i = 0; i < sections.length; i++)
	{
		page = sections[i].startPage;
		while(page && page.section == i)
		{
			if(page.pageNumberKind == 2) pageNo = 1;
			page.pageNumber = pageNo;
			prev = page;
			page = page.nextPage;
			if(page && page.pageNumberKind != 1) pageNo++;
			if(prev == page) alert("Aha! bugger up!");
		}
		sections[i].lastPage = prev;
	}
	var totalPages = 0;
	for(var i = sections.length-1; i >= 0; i--)
	{
		page = sections[i].lastPage;
		while(page && page.section == i)
		{
			if(totalPages == 0) totalPages = page.pageNumber;
			page.totalPages = totalPages;
			if(page.pageNumberKind == 2) totalPages = 0;
			page = page.prevPage;
		}
	}
}

function controlPrintScore()
{
	window.print();
}

function controlPageIsQuestion(sectionIndex,pageIndex)
{
	if(sections[sectionIndex].pages[pageIndex].correct) return true
	else return false;
}

function controlGetPagePoints(aPage)
{
	if(aPage.percent >= 0) return aPage.percent;
	else
	{
		var lc = aPage.correct.length;
		var ls = aPage.student.length;
		var	r = 0;
		for(var i = 0; i < lc; i++)
		{
			if(i <= ls)
			{
				if(aPage.correct.charAt(i) == aPage.student.charAt(i)) r++
			}
		}
		if(lc) r = Math.round((r/lc) * 100);
		return r;
	}
}

function controlGetPageByFilename(aFilename)
{
	if(aFilename == "menu.html") return menuPage;
	else
	{
		for(var s = 0; s < sections.length; s++)
		{
			for(var p = 0; p < sections[s].pages.length; p++) if(sections[s].pages[p].filename == aFilename) return sections[s].pages[p];
		}
		if(refPages) for(var r = 0; r < refPages.length; r++) if(refPages[r].filename == aFilename) return refPages[r];
/*
		if(refPages)
		{
			for(var r = 0; r < refPages.length; r++)
			{
				alert(r + " " + refPages[r].filename + " " + aFilename);
				if(refPages[r].filename == aFilename) return refPages[r];
				alert("wasnot");
			}
		}
*/
	}
	return null;
}

function getPageByIndex(pageIndex)
{
	var n = 0;
	var	p = 0;
	for(var i = 0; i < sections.length; i++)
	{
		for(p = 0; p < sections[i].pages.length; p++)
		{
			if(n == pageIndex) return sections[i].pages[p];
			n++;
		}
	}
	return null;
}

function controlGetPageByID(aPageID)
{
	var r = controlFindPageByID(aPageID);
	if(!r) r = controlFindRefByID(aPageID);
	if(!r && menuPage && menuPage.pageID == aPageID) r = menuPage;
	return r;
}

function controlGetPageByTagID(tagID)
{
	var r = controlFindPageByTagID(tagID);
	if(!r) r = controlFindRefByTagID(tagID);
	if(!r && menuPage && menuPage.tagID == tagID) r = menuPage;
	return r;
}

function getQuestionByIndex(questionIndex)
{
	var n = 0;
	var	p = 0;
	var	aPage = null;
	for(var i = 0; i < sections.length; i++)
	{
		for(p = 0; p < sections[i].pages.length; p++)
		{
			if(sections[i].pages[p].isQuestion)
			{
				if(n == questionIndex) return sections[i].pages[p];
				n++;
			}
		}
	}
	return null;
}

function controlGetQuestionTitleN(questionNum)
{
	var aPage = getQuestionByIndex(questionNum);
	if(aPage) return aPage.title;
	else return "";
}

function controlGetQuestionScoreN(questionNum)
{
	var aPage = getQuestionByIndex(questionNum);
	if(aPage) return controlGetPagePoints(aPage)
	else return 0;
}

function controlGetQuestionDurationN(questionNum)
{
	var aPage = getQuestionByIndex(questionNum);
	if(aPage) return aPage.duration;
	else return 0;
}

function controlGetSectionAttemptedCount(aSection)
{
	var	r = 0;
	var aPage = null;
	for(var i = 0; i < aSection.pages.length; i++)
	{
		aPage = aSection.pages[i];
		if(aPage.isQuestionCount)
		{
			if(aPage.attempted) r++;
		}
	}
	return r;
}

function controlGetSectionAttemptedCountN(sectionNum)
{
	return controlGetSectionAttemptedCount(sections[sectionNum]);
}

function controlGetSectionPoints(aSection)
{
	var	r = 0;
	var aPage = null;
	for(var i = 0; i < aSection.pages.length; i++)
	{
		aPage = aSection.pages[i];
		if(aPage.isQuestion) r += controlGetPagePoints(aPage);
	}
	return r;
}

function controlGetSectionScore(aSection)
{
	if(aSection.questionCount)
	{
		var p = controlGetSectionPoints(aSection);
		return Math.round(p/aSection.questionCount);
	}
	else return 0;
}

function controlGetSectionScoreN(sectionNum)
{
	return controlGetSectionScore(sections[sectionNum]);
}

function controlGetSectionDuration(aSection)
{
	var r = 0;
	for(var i = 0; i < aSection.pages.length; i++) r += aSection.pages[i].duration;
	return r;
}

function controlGetSectionDurationN(sectionNum)
{
	return controlGetSectionDuration(sections[sectionNum]);
}

function controlGetSectionTitleN(sectionNum)
{
	return sections[sectionNum].title;
}

function controlGetSectionQuestionCountN(sectionNum)
{
	return sections[sectionNum].questionCount;
}

function controlGetLearningComplete()
{
	if(controlModuleComplete) return true;
	for(var i = 0; i < sections.length; i++)
	{
		var aSection = sections[i];
		if(!aSection.optional && aSection.runMode == 0) if(!aSection.completed) return false;
	}
	return true;
}

function controlGetModuleComplete()
{
	if(controlModuleComplete) return true;
	for(var i = 0; i < sections.length; i++)
	{
		var aSection = sections[i];
		if(!aSection.optional) if(!aSection.completed) return false;
	}
	return true;
}

function controlSetModuleComplete()
{
	for(var i = 0; i < sections.length; i++)
	{
		sections[i].completed = true;
	}
	controlModuleComplete = true;
}

function controlGetSectionInc(aSection)
{
	var gs = false;
	if(moduleAssessment)
	{
		if(aSection.runMode == 1 || aSection.runMode == 2) gs = true;
		else gs = false;
	}
	else gs = true;
	return gs;
}

function controlCountSectionsWithQuestions()
{
	var tmp = 0;
	for(var i = 0; i < sections.length; i++)
	{
		if(sections[i].questionCount) tmp++;
	}
	return tmp;
}

function controlGetModulePoints()
{
	var r = 0;
	for(var i = 0; i < sections.length; i++)
	{
		aSection = sections[i];
		if(controlGetSectionInc(aSection)) r += controlGetSectionPoints(aSection);
	}
	return r;
}

function controlGetModuleQuestionCount()
{
	var r = 0
	for(var i = 0; i < sections.length; i++)
	{
		aSection = sections[i];
		if(controlGetSectionInc(aSection)) r += aSection.questionsReq;
	}
	return r;
}

function controlGetModuleAttemptedCount()
{
	var r = 0
	for(var i = 0; i < sections.length; i++)
	{
		aSection = sections[i];
		if(controlGetSectionInc(aSection)) r += controlGetSectionAttemptedCount(aSection);
	}
	return r;
}

function controlGetModuleScore()
{
	var c = controlGetModuleQuestionCount();
	var p = controlGetModulePoints();
	if(c)return Math.round(p/c);
	else return 0;
}

function controlGetModuleStatus()
{
	if(controlGetModuleComplete())
	{
		if(moduleAssessment)
		{
			if(controlGetModuleScore() >= modulePassmark) return "P";
			else return "F";
		}
		else return "C";
	}
	else return "I";
}

function controlExpandModuleStatus(cStatus)
{
	switch(cStatus)
	{
		case "C": return "completed";
		case "F": return "failed";
		case "I": return "incomplete";
		case "P": return "passed";
	}
}

function controlGetModuleDurationSeconds()
{
	var r = 0
	var aSection = null;
	for(var i = 0; i < sections.length; i++) r += controlGetSectionDuration(sections[i]);
	return r;
}

function controlFormatDateTime(aDate)
{
	var tmp = aDate.getFullYear();
	n = aDate.getMonth();
	n++;
	if(n <= 9) tmp = tmp + "-0" + n;
	else tmp = tmp + "-" + n;
	n = aDate.getDate();
	if(n <= 9) tmp = tmp + "-0" + n;
	else tmp = tmp + "-" + n;
	n = aDate.getHours();
	if(n <= 9) tmp = tmp + " 0" + n;
	else tmp = tmp + " " + n;
	n = aDate.getMinutes();
	if(n <= 9) tmp = tmp + ":0" + n;
	else tmp = tmp + ":" + n;
	return tmp;
}

function controlGetPageScoreData(aPage)
{
	var tmp = '"' + aPage.title + '",';
	tmp = tmp + aPage.duration + ',';
	tmp = tmp + '"' + aPage.student + '",';
	tmp = tmp + controlGetPagePoints(aPage) + "%";
	return tmp;
}

function controlGetSignonData()
{
	var tmp = "";
	if(user.signedOn)
	{
		tmp = '"' + user.firstName + '",';
		tmp = tmp + '"' + user.lastName + '",';
		tmp = tmp + '"' + user.additional1 + '"';
		tmp = tmp + ',"' + user.additional2 + '",';
		tmp = tmp + '"' + user.additional3 + '"';
	}
	else tmp = '"","","","",""';
	return tmp;
}

function controlDoubleDoubleQuote(s)
{
	var tmp = "";
	for(var i = 0; i < s.length; i++)
	{
		if(s.charAt(i) == '"') tmp = tmp + '"';
		tmp = tmp + s.charAt(i);
	}
	return tmp;
}

function controlCalcCheckSum(s)
{
	var a = 0;
	for(var i = 0; i < s.length; i++) a += s.charCodeAt(i);
	return a;
}

function controlAssembleScoreData()
{
	var numSections = 0;
	var tmp = 'AB,"' + controlWindow.moduleID +'"';
	tmp = tmp + "," + controlGetSignonData();
	tmp = tmp + "," + controlFormatDateTime(new Date());
	tmp = tmp + "," + controlGetModuleStatus();
	tmp = tmp + "," + controlGetModuleDurationSeconds();
	tmp = tmp + "," + controlGetModuleScore();
	if(scoreDetail >= 2) numSections = controlCountSectionsWithQuestions();
	tmp = tmp + "," + numSections;
	if(scoreDetail >= 2)
	{
		for(var s = 0; s < sections.length; s++)
		{
			aSection = sections[s];
			if(aSection.questionCount > 0)
			{
				tmp = tmp + "," + controlGetSectionDuration(aSection);
				tmp = tmp + "," + controlGetSectionScore(aSection);
				if(scoreDetail >= 3)
				{
					tmp = tmp + "," + aSection.questionCount;
					for(var p = 0; p < aSection.pages.length; p++)
					{
						aPage = aSection.pages[p];
						if(aPage.isQuestion)
						{
							if(aPage.attempted)
							{
							tmp = tmp + "," + aPage.duration;
							tmp = tmp + "," + controlGetPagePoints(aPage);
							tmp = tmp + ',"' + controlDoubleDoubleQuote(aPage.student) + '"';
							}
							else tmp = tmp + ",,,";
						}
					}
				}
				else tmp = tmp + ",0";
			}
		}
	}
	return tmp;
}

function controlSendScores(aScript,aFilename,aScoreData)
{
	var scoreForm = scoreWindow.document.getElementById("scoreForm");
	if(scoreForm)
	{
		scoreForm.filename.value = aFilename;
		scoreForm.data.value = aScoreData;
		scoreForm.debug.value = scoreDebug;
		scoreForm.action = aScript;
		scoreForm.submit();
	}
	else alert("Cannot find scoreForm");
}

// detect supported browser
var agt = navigator.userAgent.toLowerCase();
if (agt.indexOf("opera") != -1) detectedOpera = true;
if (agt.indexOf("firefox") != -1) detectedFirefox = true;
if (agt.indexOf("safari") != -1) detectedSafari = true;
if (agt.indexOf("chrome") != -1) detectedChrome = true;
if (agt.indexOf("msie") != -1) detectedIE = true;
if (detectedSafari || detectedChrome) detectedSafariOrChrome = true;


