/*
	Software Copyright (c) 1985-2013 The Acteon Consultancy LLP

	Seminar 7.5.8.1007 - DIAMOND
	
	run-mode: 0 = learning, 1 = assessment, 2 = exam, 3 = survey
	btnObj.state 0 = up, 1 = over, 2 = down, 3 = disabled

*/

if(isSmoothLoading) effectiveParent = parent.parent;
else effectiveParent = parent;						    

var controlWindow = effectiveParent.controlWindow;
var timeOuts = new Array();
var clockDrift = 0;

function coreIsIE()
{
	return controlWindow.controlIsIE();
}    

function coreGetPageID()
{
	return controlWindow.controlGetPageID();
}

function coreLoadPageByFilename(aFilename)
{
	controlWindow.controlLoadPageByFilename(aFilename);
}

function coreLoadPageByID(aPageID)
{
	controlWindow.controlLoadPageByID(aPageID);
}

function coreEvalSafe(aName)
{
	var aReturn = null;
	try {aReturn = eval(aName);}
	catch(er) {}
	return aReturn;
}

function coreCenterY(fixedObj,moveObj)
{
	var foTop = parseInt(fixedObj.style.top); 
	var foHeight = parseInt(fixedObj.style.height);
	var moHeight = parseInt(moveObj.style.height);
	var newTop = Math.round((foHeight-moHeight)/2) + foTop;
	moveObj.style.top = newTop + "px";
}

function coreCenterX(fixedObj,moveObj)
{
	ol = parseInt(fixedObj.style.left,10);
	ow = parseInt(fixedObj.style.width,10);
	iw = parseInt(moveObj.style.width,10);
	var newLeft = Math.round(ol + ((ow-iw)/2)) + "px";
	moveObj.style.left = newLeft;
}

function coreCenterXY(fixedObj,moveObj)
{
	ol = parseInt(fixedObj.style.left,10);
	ot = parseInt(fixedObj.style.top,10);
	ow = parseInt(fixedObj.style.width,10);
	oh = parseInt(fixedObj.style.height,10);
	iw = parseInt(moveObj.style.width,10);
	ih = parseInt(moveObj.style.height,10);
	var newLeft = Math.round(ol + ((ow-iw)/2)) + "px";
	var	newTop = Math.round(ot + ((oh-ih)/2)) + "px";
	moveObj.style.left = newLeft;
	moveObj.style.top = newTop;
}

function corePositionLeft(fixedObj,moveObj)
{
	var fixedLeft = parseInt(fixedObj.style.left,10);
	var moveWidth = parseInt(moveObj.style.width,10);
	var moveLeft = fixedLeft - moveWidth;
	moveObj.style.left = moveLeft + "px";
	coreCenterY(fixedObj,moveObj);
}

function corePositionRight(fixedObj,moveObj)
{
	var fixedLeft = parseInt(fixedObj.style.left,10);
	var fixedWidth = parseInt(fixedObj.style.width,10);
	var moveLeft = fixedLeft + fixedWidth;
	moveObj.style.left = moveLeft + "px";
	coreCenterY(fixedObj,moveObj);
}

var pageStartTime = 0;
var	pageDuration = 0;

function coreStartPageTimer()
{
	pageStartTime = new Date().getTime();
	pageDuration = 0;
}

function coreStopPageTimer()
{
	var endTime = new Date().getTime();
	pageDuration = Math.round((endTime - pageStartTime)/1000);
	pageStartTime = 0;
	scoresPostDuration(pageDuration);
	return pageDuration;
}

function coreFormatElapsedTime(elapsedSeconds)
{
	var sep = "";
	var s = "";
	var t = Math.round(elapsedSeconds);
	for (var i = 0; i < 3; i++)
	{
		var t1 = t%60;
		s = (t1<10? '0':'') + t1 + sep + s;
		sep = ":";
		t = Math.floor(t/60);
	}
	return s;
}

function coreFormatDateTime(aDate)
{
	var n = aDate.getMonth();
	if(n <= 9) tmp = tmp + "-0" + n;
	else tmp = tmp + "-" + n;
	n = aDate.getDate();
	if(n <= 9) tmp = tmp + "-0" + n;
	else tmp = tmp + "-" + n;
	n = aDate.getHours();
	if(n <= 9) tmp = tmp + " 0" + n;
	else tmp = tmp + " " + n;
	n = aDate.getMinutes();
	if(n <= 9) tmp = tmp + ":0" + n;
	else tmp = tmp + ":" + n;
	return tmp;
}

function coreChangeBtnImage(senderObj,btnImg)
{
	if(senderObj.style.filter) senderObj.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src=\'" + btnImg.src + "\')";
	else senderObj.style.background = "url(" + btnImg.src + ")"; 
}


function coreChangeBkgImage(obj,imgName)
{
	if(obj.style.filter)
	{ // Only IE6 will have a Filter
		obj.style.filter = "";
		obj.style.backgroundImage = "url(" + imgName + ")";
		return;
	}
	if(obj.style.backgroundImage)
	{
		obj.style.backgroundImage = "url(" + imgName + ")";
		return;
	}
	if(obj.style.background)
	{
		obj.style.background= "url(" + imgName + ")"; 
		return;
	}
}


function coreBtnOver(senderObj)
{
	var btnObj = eval(senderObj.id + "Btn");
	if(!(btnObj.staydown & btnObj.state == 2))
	{
		if(btnObj.state != 3 && btnObj.state != 2)
		{
			coreChangeBtnImage(senderObj,btnObj.overImg);
			btnObj.state = 1;
			if(btnObj.newButton) coreBtnExState(senderObj,btnObj.state);
		}
	}
}

function coreBtnOut(senderObj)
{
	var btnObj = eval(senderObj.id + "Btn");
	if(!(btnObj.staydown & btnObj.state == 2))
	{
		if(btnObj.state != 3 && btnObj.state != 2)
		{
			coreChangeBtnImage(senderObj,btnObj.upImg);
			btnObj.state = 0;
			if(btnObj.newButton) coreBtnExState(senderObj,btnObj.state);
		}
	}
}

function coreBtnDown(senderObj)
{
	var btnObj = eval(senderObj.id + "Btn");
	if(btnObj.state != 3)
	{
		coreChangeBtnImage(senderObj,btnObj.downImg);
		btnObj.state = 2;
		if(btnObj.newButton) coreBtnExState(senderObj,btnObj.state);
	}
}

function coreBtnUp(senderObj)
{
	var btnObj = eval(senderObj.id + "Btn");
	if(btnObj.state != 3)
	{
		coreChangeBtnImage(senderObj,btnObj.upImg);
		btnObj.state = 0;
		if(btnObj.newButton) coreBtnExState(senderObj,btnObj.state);
	}
}

function coreBtnDisable(senderObj)
{
	var btnObj = eval(senderObj.id + "Btn");
	if(btnObj.state != 3)
	{
		if(btnObj.disableImg) coreChangeBtnImage(senderObj,btnObj.disableImg);
		else senderObj.style.visibility = "hidden";
		senderObj.style.cursor = "default";
		btnObj.state = 3;
		if(btnObj.newButton) coreBtnExState(senderObj,btnObj.state);
	}
}

function coreDisableButtonId(buttonId)
{
	var obj = document.getElementById(buttonId);
	if(obj) coreBtnDisable(obj);
}

function coreEnableButtonId(buttonId)
{
	var obj = document.getElementById(buttonId);
	if(obj) coreBtnEnable(obj);
}

function coreBtnEnable(senderObj)
{
	var btnObj = eval(senderObj.id + "Btn");
	if(btnObj.state = 3)
	{
		senderObj.style.visibility = "visible";
		coreChangeBtnImage(senderObj,btnObj.upImg);
		if(coreIsIE()) senderObj.style.cursor = "hand";
		else senderObj.style.cursor = "pointer";
		btnObj.state = 0;
		coreBtnOver(senderObj);
		coreBtnOut(senderObj);
	}
}

function coreGetBtnIsDisabled(senderObj)
{
	var btnObj = eval(senderObj.id + "Btn");
	if(btnObj.state == 3) return true;
	else return false;
}

function coreBtnExState(senderObj,aState)
{
	var captionObj = eval(senderObj.id + "_cspan");
	var btnObj = eval(senderObj.id + "Btn");
	captionObj.style.color = btnObj.sxd[aState].color;
	captionObj.style.fontFamily = btnObj.sxd[aState].fontFamily;
	captionObj.style.fontSize = btnObj.sxd[aState].fontSize;
	captionObj.style.fontWeight = btnObj.sxd[aState].fontWeight;
	var captionNode = document.getElementById(captionObj.id);
	captionNode.lastChild.nodeValue = btnObj.sxd[aState].caption;
	var captionOfs = eval(senderObj.id + "_cdiv");
	captionOfs.style.left = btnObj.sxd[aState].cdivLeft;
	captionOfs.style.top = btnObj.sxd[aState].cdivTop;
}

function coreEnableContinue()
{
	btnObj = coreEvalSafe("ContinueBtn");
	if(btnObj) 
	{
		coreBtnEnable(document.getElementById('Continue'));
		document.getElementById('continuebtndiv').style.zIndex = 2001;
	}
	else
	{
		btnObj = coreEvalSafe("FinishBtn");
		if(btnObj) 
		{
			coreBtnEnable(document.getElementById('Finish'));
			document.getElementById('finishbtndiv').style.zIndex = 2001;
		}
	}
	if(controlWindow.moduleLinkForwardButton) coreEnableButtonId("Forward");
}

function coreDisableContinue()
{
	btnObj = coreEvalSafe("ContinueBtn");
	if(btnObj) 
	{
		coreBtnDisable(document.getElementById('Continue'))
		document.getElementById('continuebtndiv').style.zIndex = 1;
	}
	else
	{
		btnObj = coreEvalSafe("FinishBtn");
		if(btnObj) 
		{
			coreBtnDisable(document.getElementById('Finish'));
			document.getElementById('finishbtndiv').style.zIndex = 1;
		}
	}
	if(controlWindow.moduleLinkForwardButton) coreDisableButtonId("Forward");
}

function coreDisableSubmit()
{
	coreBtnDisable(document.getElementById("submit"));
}

function coreEnableSubmit()
{
	coreBtnEnable(document.getElementById("submit"));
}

function coreGetHasSubmit()
{
	var sb = document.getElementById("submit");
	if(sb) return true;
	else return false;
}	

function coreShowObjectId(aObjectId)
{
	coreShowObject(document.getElementById(aObjectId));
}

function coreHideShowObject(aObject,vis)
{
	if(aObject) 
	{
		aObject.style.visibility = vis;
		var shadow = document.getElementById(aObject.id + "_shadow");
		if(shadow) shadow.style.visibility = vis;
	}
}

function coreShowObject(aObject)
{
	coreHideShowObject(aObject,"visible");
}

function coreHideObjectId(aObjectId)
{
	coreHideObject(document.getElementById(aObjectId));
}

function coreHideObject(aObject)
{
	coreHideShowObject(aObject,"hidden");
}

function coreToggleVisibilityObject(aObject)
{
	if(aObject)
	{
		if(aObject.style.visibility == "hidden") aObject.style.visibility = "visible";
		else if(aObject.style.visibility == "visible") aObject.style.visibility = "hidden";
	}
}


var	currentPopup = null;

function coreSetCurrentPopup(aPopup)
{
	currentPopup = aPopup;
}

function coreGetCurrentPopup(aPopup)
{
	return currentPopup;
}

function coreShowPopupN(aPopupName,doContinue)
{
	var aPopup = document.getElementById(aPopupName);
	coreShowPopup(aPopup,doContinue);
}

function coreShowPopup(aPopup,doContinue)
{
	if(currentPopup) currentPopup.style.visibility = "hidden";
	document.getElementById('glass').style.visibility = "visible";
	aPopup.style.visibility = "visible";
	currentPopup = aPopup;
	currentPopup.doContinue = doContinue;
}

function coreClosePopup()
{
	if(currentPopup)
	{
		currentPopup.style.visibility = "hidden";
		if(currentPopup.doContinue) coreEnableContinue();
		currentPopup = null;
	}
	document.getElementById("glass").style.visibility = "hidden";
}

function coreColorResponse(aResponse,isCorrect)
{
	var tb = document.getElementById(aResponse.id + "_tb");
	if(isCorrect) 
	{
		coreChangeBkgImage(aResponse,responseBkg + "_green.png");
		if(tb) tb.style.background = correctColor;
	}
	else
	{
		coreChangeBkgImage(aResponse,responseBkg + "_red.png");
		if(tb) tb.style.background = incorrectColor;
	}
}

function coreShowDefaultResponse(aStudentStr,aAnswerStr)
{
	var l = aStudentStr.length;
	if(aAnswerStr.length < l) l = aAnswerStr.length;
	var i = 0;
	var	c = 0;
	for(i = 0; i < l; i++) if(aAnswerStr.charAt(i) == aStudentStr.charAt(i)) c++;
	if(c == l) coreDefaultOrCustomResponse(responseAll);
	else if(c) coreDefaultOrCustomResponse(responseSome);
		else coreDefaultOrCustomResponse(responseNone);
}

function coreDefaultOrCustomResponse(aResponse)
{
	if(aResponse) coreShowPopup(aResponse);
	else coreShowPopup(responseCustom);
}

function corePrintClick()
{
	controlWindow.controlPrintScore();
}

function coreGetStudentName()
{
	if(controlWindow.deliveryTarget == 1) return controlWindow.scormStudentName()
	else return scoresGetSignOn(0) + " " + scoresGetSignOn(1);
}

function coreExtractStudentName(isFirst)
{
	var aName = controlWindow.scormStudentName();
	if(aName)
	{
		var aNames = aName.split(",");
		if(aNames.length < 2) return aName;
		if(isFirst) return aNames[1].replace(/^\s+|\s+$/g,"");
		else return aNames[0].replace(/^\s+|\s+$/g,"");
	}
}

function coreGetStudentFirstName()
{
	if(controlWindow.deliveryTarget == 1) return coreExtractStudentName(true);
	else return scoresGetSignOn(0);
}

function coreGetStudentLastName()
{
	if(controlWindow.deliveryTarget == 1) return coreExtractStudentName(false);
	else return scoresGetSignOn(1);
}

function coreGetStudentId()
{
	if(controlWindow.deliveryTarget == 1) return controlWindow.scormStudentId()
	else return scoresGetSignOn(3);
}


// tag functions are quasi-private: do not call from outside core.js

function tagDate()
{
	var	d = new Date();
	return d.getDate() + "/" + (d.getMonth()+1) + "/" + d.getFullYear();
}

function tagTime()
{
	var d = new Date();
	var h = d.getHours();
	var m = d.getMinutes();
	return h + ":" + (m < 10 ? "0":"") + m;
}

function tagPageNumber()
{
	var r = 0;
	if(controlWindow.currentPage && controlWindow.currentPage.pageNumber) {r = controlWindow.currentPage.pageNumber;}
	return r + "";
}

function tagTotalPages()
{
	var r = 0;
	if(controlWindow.currentPage && controlWindow.currentPage.totalPages) {r = controlWindow.currentPage.totalPages;}
	return r + "";
}

function tagPageTitle(param)
{
	if(param) return scoresGetQuestionTitle(param);
	else return controlWindow.currentPage.title;
}

function tagGetTotalAnswered()
{
	var r = scoresGetTotalAnswered();
	if(r) return r;
	else return "0";
}

function tagGetQuestionNumber()
{
	return controlWindow.controlQuestionNumber;
}

function tagGetSectionAnswered(param)
{
	r = scoresGetSectionAnswered(param);
	if(r) return r;
	else return "0";
}

function tagGetSectionTitle(param)
{
	if(param < 0) param = controlWindow.currentPage.section;
	return scoresGetSectionTitle(param);
}

function coreExpandTag(tagStr)
{
	var	splitTag = tagStr.split("#");
	if(splitTag.length > 1)
	{
		var param = parseInt(splitTag[1]);
		if(isNaN(param)) param = 0;
		var tagS = splitTag[0] + "~";
	}
	else
	{
		var param = 0;
		var tagS = tagStr;
	}
	param--;
	var	repStr = "";
	if (tagS == "~DATE~") repStr = tagDate();
	if (tagS == "~TIME~") repStr = tagTime();
	if (tagS == "~NAME~") repStr = coreGetStudentName();
	if (tagS == "~FIRSTNAME~") repStr = coreGetStudentFirstName();
	if (tagS == "~LASTNAME~") repStr = coreGetStudentLastName()
	if (tagS == "~ADDITIONAL1~") repStr = scoresGetSignOn(2);
	if (tagS == "~ADDITIONAL2~") repStr = scoresGetSignOn(3);
	if (tagS == "~ADDITIONAL3~") repStr = scoresGetSignOn(4);
	if (tagS == "~MODULETITLE~") repStr = scoresGetModuleTitle();
	if (tagS == "~MPM~") repStr = scoresGetPassmark() + "%";
	if (tagS == "~MST~") repStr = scoresGetMST();
	if (tagS == "~TSC~") repStr = scoresGetTotalScore();
	if (tagS == "~TNQ~") repStr = scoresGetTotalQuestions();
	if (tagS == "~Q~") repStr = scoresGetTotalQuestions();
	if (tagS == "~TNA~") repStr = tagGetTotalAnswered();
	if (tagS == "~A~") repStr = tagGetTotalAnswered();
	if (tagS == "~C~") repStr = tagGetQuestionNumber();
	if (tagS == "~TDR~") repStr = coreFormatElapsedTime(scoresGetTotalDuration());
	if (tagS == "~SECTIONTITLE~") repStr = tagGetSectionTitle(param);
	if (tagS == "~SSC~") repStr = scoresGetSectionScore(param);
	if (tagS == "~SNQ~") repStr = scoresGetSectionQuestions(param);
	if (tagS == "~SNA~") repStr = tagGetSectionAnswered(param);
	if (tagS == "~SDR~") repStr = coreFormatElapsedTime(scoresGetSectionDuration(param));
	if (tagS == "~QUESTIONTITLE~") repStr = tagPageTitle(param);
	if (tagS == "~QS~") repStr = scoresGetQuestionScore(param);
	if (tagS == "~QD~") repStr = coreFormatElapsedTime(scoresGetQuestionDuration(param));
	if (tagS == "~PN~" || tagS == "~PS~" || tagS == "~PR~") repStr = tagPageNumber();
	if (tagS == "~N~" || tagS == "~S~" || tagS == "~R~") repStr = tagPageNumber();
	if (tagS == "~TP~") repStr = tagTotalPages();
	if (tagS == "~T~") repStr = tagTotalPages();
	if (tagS == "~VER~") repStr = seminarVersion;
	if (tagS == "~PRM~") repStr = pageRunModeS;
	if (tagS == "~MRM~") repStr = moduleRunModeS;									   
	if(!repStr) repStr = tagStr;
	return repStr;
}

function coreExpandTildeTags(tagStr,aDiv)
{
	var repStr = coreExpandTag(tagStr);
	if(aDiv) aDiv.innerHTML = aDiv.innerHTML.replace(tagStr,repStr);
	else document.body.innerHTML = document.body.innerHTML.replace(tagStr,repStr);
}

function formatHHMM(sec)
{
	var s = sec % 60;
	var m = (sec - s) / 60;
	var r = (m < 10 ? "0":"") + m + ":" + (s < 10 ? "0":"") + s;
	return r;
}

var	savedHTML = "";
	timerDiv = null;

function coreGetClockDrift()
{
    try
    {
        var client = new XMLHttpRequest();
        client.open("HEAD", "control.html", true);
        client.send();
        client.onreadystatechange = function()
            {
				try // fix for #8873
				{
					if(this.readyState == 2)
					{
						var headerDateStr = this.getResponseHeader("Date");
						var serverTime = new Date(headerDateStr).getTime();
						var msNow = new Date().getTime();
						clockDrift = serverTime - msNow;
						if(!controlWindow.controlClockDriftChecked) 
						{
							controlWindow.controlStartClockDrift = clockDrift;
							controlWindow.controlClockDriftChecked = true;
						}
						var cd = clockDrift;
						var scd = controlWindow.controlStartClockDrift;
						clockDrift -= controlWindow.controlStartClockDrift;
					}
				}
				catch(e){ clockDrift = 0;}
            }
    }
    catch(e)
    {
        clockDrift = 0;
    }
}

function coreModuleTimerEvent(forceUpdate)
{
	var msNow = new Date().getTime();
	if(!isNaN(clockDrift)) msNow += clockDrift;
	var elapsedSeconds = Math.round((msNow - controlWindow.controlTimedModuleStartMS)/1000);
	controlWindow.moduleTimerLeft = controlWindow.moduleTimer - elapsedSeconds;
	if(controlWindow.moduleTimerLeft < 0) controlWindow.moduleTimerLeft = 0;
	if(forceUpdate || controlWindow.moduleTimerLeft % 5 == 0)
	{
		var repStr = formatHHMM(controlWindow.moduleTimerLeft);
		timerDiv.innerHTML = savedHTML.replace("~TIMER~",repStr);
	}
	if(controlWindow.moduleTimerLeft) setTimeout("coreModuleTimerEvent(false);",1000);
	else
	{
		alert(controlWindow.moduleTimeoutMsg);
		controlWindow.controlFinishAllSections();
		controlWindow.controlFinish();
	}
}

function coreModuleTimerStart(aDiv)
{
	timerDiv = aDiv;
	savedHTML = aDiv.innerHTML;
	if(!controlWindow.controlTimedModuleStartMS) controlWindow.controlTimedModuleStartMS = new Date().getTime();
	coreModuleTimerEvent(true);
}

function coreLoadingDiv(i,d)
{
	if(i.src)
	{
		i.style.visibility = "visible";
		d.style.visibility = "hidden";
	}
}

function coreInitialButtonStates()
{
	var buttonId;
	var hiddens = controlWindow.currentPage.initialHiddenBtns;
	if(hiddens)
	{
		for(var i = 0; i < hiddens.length; i++)
		{
			buttonId = hiddens[i];
			coreHideObjectId(buttonId);
		}
	}
	var disables = controlWindow.currentPage.initialDisabledBtns;
	if(disables)
	{
		for(var i = 0; i < disables.length; i++)
		{
			buttonId = disables[i];
			if(buttonId == "Continue")
			{
				coreDisableContinue();
			}
			else
			{
				coreDisableButtonId(buttonId);
			}
		}
	}
}

if(typeof(document.all) == 'object') document.onselectstart = new Function('return false');
coreGetClockDrift();
