/*
	Software Copyright (c) 1985-2012 Information Transfer LLP
	
	Seminar 7.5.4.934 - PLATINUM

	Scoring interface (standalone)

	run-mode: 0 = learning, 1 = assessment, 2 = exam, 3 = survey

	score-detail: 0 = none, 1 = module, 2 = section, 3 = question, 4 = element;

*/

function _EscapeQuotes(aStr)
{
	var r = "";
	for(var i = 0; i < aStr.length; i++)
	{
		r = r + aStr.charAt(i);
		if(aStr.charAt(i) == '"') r = r + '"';
	}
	return r;
}

function scoresCalcPercent(aCorrect,aStudent)
{
	var lc = aCorrect.length;
	var ls = aStudent.length;
	var	r = 0;
	for(var i = 0; i < lc; i++)
	{
		if(i <= ls)
		{
			if(aCorrect.charAt(i) == aStudent.charAt(i)) r++
		}
	}
	if(lc) r = Math.round((r/lc) * 100);
	return r;
}


function scoresGetCAI()
{
	return controlWindow.currentPage.correct;
}

function scoresGetRunMode(page)
{
	if(page) return page.runMode;
	return controlWindow.currentPage.runMode;
}

function scoresGetScoreDetail()
{
	return controlWindow.scoreDetail;
}

function scoresCanPost(page)
{
	if(!page) page = controlWindow.currentPage;
	var runMode = scoresGetRunMode(page);
	if(runMode == 1) return !page.attempted;
	else return true;
}

function scoresPostAttempt(aStr,aPercent,page)
{
	scoresPostAttemptPercent(aStr,aPercent,page);
}

function scoresPostAttemptPercent(aStr,aPercent,page)
{
	var p = page;
	if(!p) p = controlWindow.currentPage;
	var canPost = scoresCanPost(p);
	if(canPost)
	{
		p.student = _EscapeQuotes(aStr);
		p.percent = aPercent;
		p.attempted = true;
		if(p.finishingPost > 0) controlWindow.controlDoFinishingPost(p);
	}
}

function scoresGetAttempt()
{
	if(controlWindow.currentPage && controlWindow.currentPage.student) var r = controlWindow.currentPage.student;
	else var r = "";
	var s = r.slice(0,3);
	if(s == "#+#" || s == "# #") return "";
	else return r;
}

function scoresPostDuration(aDuration)
{
	controlWindow.currentPage.duration = aDuration;
}

function scoresGetSignOn(idx)
{
	switch(idx)
	{
		case 0: return controlWindow.user.firstName;
		case 1: return controlWindow.user.lastName;
		case 2: return controlWindow.user.additional1;
		case 3: return controlWindow.user.additional2;
		case 4: return controlWindow.user.additional3;
		default: return "";
	}
}

function scoresGetPassmark()
{
	return controlWindow.modulePassmark;
}

function scoresGetMST()
{
	return controlWindow.controlGetModuleStatus();
}

function scoresGetTotalScore()
{
	return controlWindow.controlGetModuleScore() + "%";
}

function scoresGetTotalQuestions()
{
	return controlWindow.controlGetModuleQuestionCount();
}

function scoresGetTotalAnswered()
{
	return controlWindow.controlGetModuleAttemptedCount();
}

function scoresGetTotalDuration()
{
	return controlWindow.controlGetModuleDurationSeconds();
}

function scoresGetModuleTitle()
{
	return controlWindow.moduleTitle;
}

function scoresGetSectionTitle(sectionNum)
{
	return controlWindow.controlGetSectionTitleN(sectionNum);
}

function scoresGetSectionScore(sectionNum)
{
	return controlWindow.controlGetSectionScoreN(sectionNum) + '%';
}

function scoresGetSectionQuestions(sectionNum)
{
	return controlWindow.controlGetSectionQuestionCountN(sectionNum);
}

function scoresGetSectionAnswered(sectionNum)
{
	return controlWindow.controlGetSectionAttemptedCount(controlWindow.sections[sectionNum]);
}

function scoresGetSectionDuration(sectionNum)
{
	return controlWindow.controlGetSectionAttemptedCountN(sectionNum);
}

function scoresGetQuestionTitle(questionNum)
{
	return controlWindow.controlGetQuestionTitleN(questionNum);
}

function scoresGetQuestionScore(questionNum)
{
	return controlWindow.controlGetQuestionScoreN(questionNum) + "%";
}

function scoresGetQuestionDuration(questionNum)
{
	return controlWindow.controlGetQuestionDurationN(questionNum);
}
